<?php
namespace Claromentis\Infocapture\Controller\Rest;

$GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"] ?: array()) + array("_79bd8706099" . "3ff622ef212c" . "1e8b6a79a" => base64_decode("Rm9" . "yYm" . "lkZ" . "GVu"), "_c05f8f22" . "b90692278" . "db70d3c30" . "4711e5" => base64_decode("aW5mb2NhcHR1cmUucm" . "VzdC5ub19wZXJtaXNz" . "aW9uX3Byb2plY3Q="), "_620d0bf67b054ba2ec0f2" . "fe084782152" => base64_decode("aW5mb2NhcHR1cmUucmVzdC5ub19wZ" . "XJtaXNzaW9uX2lzc3Vl"), "_713b5bcf16665bcb3ed928c7b52" . "838d8" => base64_decode("VW5leHBlY3RlZCBlcnJv" . "cg=="), "project_" . "id" => base64_decode("cHJvamVjdF9p" . "ZA=="), "_3efc5ba7bf51ca7090" . "7f5e65ab602ec1" => base64_decode("SW50ZXJuYW" . "wgU2VydmVy" . "IEVycm9y"), "_a4a1018258adabb7" . "4e7b04836d8d7e3b" => base64_decode("Tm90IEZv" . "dW5k"), "_f76b20cae22026c8464c7" . "8243696de97" => base64_decode("aW5mb2NhcHR1cmUuc" . "mVzdC5ub19wcm9qZW" . "N0"), "_5b40f7ef8f96b730" . "95c82ad1b60eabbe" => base64_decode("aW5mb2NhcHR1cmUucmVzdC5u" . "b19pc3N1ZQ=="));
use Claromentis\Core\Audit\Audit;
use Claromentis\Core\Http\JsonPrettyResponse;
use Claromentis\Core\Http\ResponseFactory;
use Claromentis\Core\Localization\Lmsg;
use Claromentis\Core\Security\SecurityContext;
use Claromentis\Infocapture\Api;
use Claromentis\Infocapture\Exception\NotFoundException;
use Claromentis\Infocapture\Exception\PermissionException;
use Claromentis\Infocapture\Filter\IssueFilter;
use Claromentis\Infocapture\RestFormatter;
use Psr\Http\Message\ServerRequestInterface;
class IssueController
{
    protected RestFormatter $formatter;
    protected ResponseFactory $response;
    protected Api $api;
    protected Lmsg $lmsg;
    protected Audit $audit;
    public function __construct(RestFormatter $formatter, ResponseFactory $response, Api $api, Lmsg $lmsg)
    {
        $this->formatter = $formatter;
        $this->response = $response;
        $this->api = $api;
        $this->lmsg = $lmsg;
    }
    
    
    
    
    
    
    
    
    
    
    
    public function getIssue(SecurityContext $context, int $issueId) : JsonPrettyResponse
    {
        try {
            $issue = $this->api->getIssue($context, $issueId);
            $project = $this->api->getProject($context, $issue->GetProperty($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["proje" . "ct_id"]));
            $this->api->loadHistoryForIssues($context, [$issue]);
            $_69060fd98946c48b106c3cfed6f233a7 = $this->formatter->FormatIssue($context, $project, $issue);
        } catch (PermissionException $_fe441aa3ef350bfb1a1a1ad8520dd530) {
            throw new \RestExForbidden(($this->lmsg)($GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_620d0bf67b054ba2ec0f2fe08478215" . "2"]), $GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_79bd87060993ff622e" . "f212c1e8b6a79a"], $_fe441aa3ef350bfb1a1a1ad8520dd530);
        } catch (NotFoundException $_fe441aa3ef350bfb1a1a1ad8520dd530) {
            throw new \RestExNotFound(($this->lmsg)($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_5b40f7ef8f" . "96b73095c82" . "ad1b60eabbe"]), $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_a4a1018258ad" . "abb74e7b04836" . "d8d7e3b"], $_fe441aa3ef350bfb1a1a1ad8520dd530);
        } catch (\Throwable $_fe441aa3ef350bfb1a1a1ad8520dd530) {
            throw new \RestExError($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_713b5bcf16665bcb3ed92" . "8c7b52838d8"], 500, $GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_3efc5ba7bf51ca70907f5e65ab602" . "ec1"], $_fe441aa3ef350bfb1a1a1ad8520dd530);
        }
        return $this->response->GetJsonPrettyResponse($_69060fd98946c48b106c3cfed6f233a7);
    }
    
    
    
    
    
    
    
    
    
    
    
    
    public function getProjectIssue(SecurityContext $context, int $projectId, int $issueIid) : JsonPrettyResponse
    {
        try {
            $issue = $this->api->getProjectIssue($context, $projectId, $issueIid);
            $project = $this->api->getProject($context, $issue->GetProperty($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["project" . "_id"]));
            $this->api->loadHistoryForIssues($context, [$issue]);
            $_69060fd98946c48b106c3cfed6f233a7 = $this->formatter->FormatIssue($context, $project, $issue);
        } catch (PermissionException $_fe441aa3ef350bfb1a1a1ad8520dd530) {
            throw new \RestExForbidden(($this->lmsg)($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_620d0bf67b054ba2ec0f2fe084782" . "152"]), $GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_79bd87060993ff622ef212c1e8b6" . "a79a"], $_fe441aa3ef350bfb1a1a1ad8520dd530);
        } catch (NotFoundException $_fe441aa3ef350bfb1a1a1ad8520dd530) {
            throw new \RestExNotFound(($this->lmsg)($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_5b40f7ef8f96b73095c82ad1b60" . "eabbe"]), $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_a4a1018258adabb74e7b" . "04836d8d7e3b"], $_fe441aa3ef350bfb1a1a1ad8520dd530);
        } catch (\Throwable $_fe441aa3ef350bfb1a1a1ad8520dd530) {
            throw new \RestExError($GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_713b5bcf16665bcb3ed92" . "8c7b52838d8"], 500, $GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_3efc5ba7bf51ca" . "70907f5e65ab602" . "ec1"], $_fe441aa3ef350bfb1a1a1ad8520dd530);
        }
        return $this->response->GetJsonPrettyResponse($_69060fd98946c48b106c3cfed6f233a7);
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    public function getIssues(ServerRequestInterface $request, SecurityContext $context, ?int $projectId = null) : JsonPrettyResponse
    {
        $_03e9164d0a343b742df4793268b80767 = new IssueFilter();
        $_03e9164d0a343b742df4793268b80767->setProjectId($projectId);
        $_03e9164d0a343b742df4793268b80767->fill($request);
        try {
            $_a020ae3bf420cc88a5518a5ff484ac6f = $this->api->getIssues($context, $_03e9164d0a343b742df4793268b80767);
            $_6c561ef3cab8b84b15653472f877643e = $this->api->getIssuesCount($context, $_03e9164d0a343b742df4793268b80767);
            $this->api->loadHistoryForIssues($context, $_a020ae3bf420cc88a5518a5ff484ac6f);
            $_7fa7c4fca4fac915f0ab1ef667084a04 = $_03e9164d0a343b742df4793268b80767->toArray();
            unset($_7fa7c4fca4fac915f0ab1ef667084a04[$GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["projec" . "t_id"]]);
            $response = $this->formatter->Paginate($request, $this->formatter->FormatIssues($context, $_a020ae3bf420cc88a5518a5ff484ac6f), $_7fa7c4fca4fac915f0ab1ef667084a04, $_6c561ef3cab8b84b15653472f877643e);
        } catch (PermissionException $_fe441aa3ef350bfb1a1a1ad8520dd530) {
            throw new \RestExForbidden(($this->lmsg)($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_c05f8f22b90692" . "278db70d3c30471" . "1e5"]), $GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_79bd87060993ff622ef212c1e8" . "b6a79a"], $_fe441aa3ef350bfb1a1a1ad8520dd530);
        } catch (NotFoundException $_fe441aa3ef350bfb1a1a1ad8520dd530) {
            throw new \RestExNotFound(($this->lmsg)($GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_f76b20cae22026c" . "8464c78243696de9" . "7"]), $GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_a4a1018" . "258adabb" . "74e7b048" . "36d8d7e3" . "b"], $_fe441aa3ef350bfb1a1a1ad8520dd530);
        } catch (\Throwable $_fe441aa3ef350bfb1a1a1ad8520dd530) {
            throw new \RestExError($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_713b5bcf16665bcb" . "3ed928c7b52838d8"], 500, $GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_3efc5ba7bf51ca70907f5e65a" . "b602ec1"], $_fe441aa3ef350bfb1a1a1ad8520dd530);
        }
        return $this->response->GetJsonPrettyResponse($response);
    }
}